"use strict";

function isIndexed(e) {
  for (var r = 0; r < e.length; r++) if (e[r] < "0" || "9" < e[r]) return !1;
  return !0;
}

function isTypedArray(e) {
  return "Int8Array" === e || "Uint8Array" === e || "Uint8ClampedArray" === e || "Int16Array" === e || "Uint16Array" === e || "Int32Array" === e || "Uint32Array" === e || "Float32Array" === e || "Float64Array" === e;
}

"undefined" == typeof v8debug && "undefined" != typeof process && "undefined" != typeof Proxy && (this.v8debug = new Proxy({}, {
  get: function(e, r) {
    return process.binding("contextify").runInDebugContext("this." + r);
  }
}));

var $_JbV8DebuggerSupport;

!function(e) {
  function r(e, r) {
    return -1 != r && e.length() > r ? e.value().substring(0, r) : e.value();
  }
  function t(e, r) {
    if (e) {
      var t = e.line;
      void 0 !== t && (r.line = t);
      var n = e.column;
      void 0 !== n && (r.column = n);
    }
  }
  function n(e) {
    return i(e, "objects");
  }
  function i(e, r) {
    return null == e || 0 == e.length ? "" : ', "' + r + '": ' + JSON.stringify(e);
  }
  function o(e, r) {
    var t = e.charCodeAt(r);
    return 10 === t || 13 == t;
  }
  function a(e, r) {
    var t = e.charCodeAt(r);
    return 32 === t || 10 === t || 13 == t || 9 == t;
  }
  function s(e) {
    return isNaN(e) ? "NaN" : isFinite(e) ? e : e > 0 ? "Infinity" : "-Infinity";
  }
  var u = v8debug.ObjectMirror, c = v8debug.StringMirror, l = v8debug.FunctionMirror, p = v8debug.ArrayMirror, f = v8debug.DateMirror, g = v8debug.RegExpMirror, d = v8debug.PropertyKind, v = v8debug.ScopeDetails, h = v8debug.DebugCommandProcessor;
  f.prototype.isDate = function() {
    return !0;
  }, f.prototype.isRegExp = function() {
    return !1;
  }, f.prototype.isArray = function() {
    return !1;
  }, g.prototype.isDate = function() {
    return !1;
  }, g.prototype.isRegExp = function() {
    return !0;
  }, g.prototype.isArray = function() {
    return !1;
  }, u.prototype.isUndefined = function() {
    return !1;
  }, u.prototype.isNull = function() {
    return !1;
  };
  var y = new RegExp("[\\r\\n]//[@|#][ \\t]sourceMappingURL=[ \\t]*(?:file://)?([^\\r\\n]*)\\s*(?:\\*/\\s*)?(?:[\\r\\n]+[});]+)?(?:[\\r\\n]+//[^\\r\\n]+)?$"), b = {
    Global: 0,
    Local: 1,
    With: 2,
    Closure: 3,
    Catch: 4,
    Block: 5,
    Script: 6
  }, m = function() {
    function e(e, r, n) {
      this.scriptId = e, this.scopes = r, t(n, this);
    }
    return e;
  }();
  e.FunctionDescriptor = m;
  var O = function() {
    function e(e) {
      this.name = e;
    }
    return e;
  }();
  e.PropertyDescriptor = O;
  var S = function() {
    function e(e, r, t, n) {
      this.id = e, this.type = r, null != t && (this.description = t), -1 != n && (this.length = n);
    }
    return e;
  }();
  e.ObjectDescriptor = S;
  var M = function() {
    function e(e, r, n, i, o, a, s) {
      this.index = e, null != r && (this.functionName = r), this.functionId = n, this.scriptId = i, 
      this.scopes = o, this.hasReceiver = s, t(a, this);
    }
    return e;
  }();
  e.stringifyObjects = n, e.stringifyList = i;
  var N = function() {
    function r() {
      var t = [], n = v8debug.mirror_cache_;
      this.getMirror = function(r) {
        var i = t[r];
        if (null == i && null != n && (i = n[r]), null == i) throw new Error("Object " + r + " not found, v8debug.mirror_cache_ is " + typeof v8debug.mirror_cache_ + " " + typeof e.cacheManager.v8mc());
        return i;
      }, this.v8mc = function() {
        return n;
      }, this.clearCache = function() {
        t.length = 0;
      }, this.findMirror = function(e) {
        return r.doFindMirror(e, t);
      }, this.cacheMirror = function(e) {
        null != n && (n[e.handle()] = e), t[e.handle()] = e;
      };
    }
    return r.doFindMirror = function(e, r) {
      for (var t in r) if (r.hasOwnProperty(t)) {
        var n = r[t];
        if (n.value() === e) return n;
      }
      return null;
    }, r;
  }();
  e.CacheWrapper = N, e.cacheManager = new N();
  var _ = function() {
    function t() {}
    return t.prototype.getObjectMirror = function(r) {
      return e.cacheManager.getMirror(r);
    }, t.prototype.getFrames = function(e, r) {
      var t = r.frameCount(), i = 0, o = t;
      if (null != e.from && (i = e.from) < 0) throw new Error("Invalid from index");
      if (null != e.to && (o = Math.min(t, e.to)), o <= i) {
        if (null == e.to) return '{"totalCount": ' + t + ',"frames":[]}';
        throw new Error("Invalid frame range: from " + i + ", to " + e.to + ", total " + t);
      }
      for (var a = [], s = new Array(o - i), u = i, c = 0; u < o; u++, c++) s[c] = this.describeFrame(r.frame(u), a);
      return '{"totalCount": ' + t + ',"frames":' + JSON.stringify(s) + n(a) + "}";
    }, t.prototype.getFrameReceiver = function(e, r) {
      var t = r.frame(e.index), i = t.details_.receiver();
      if (null == i) return "{}";
      var o = [];
      return '{"objectId":' + this.getOrCreateMirror(i, o, e.includeProperties, 1e3).handle() + n(o) + "}";
    }, t.prototype.getScopeObject = function(e, r) {
      var t = void 0 === e.frameIndex ? null : r.frame(e.frameIndex), i = null === t ? this.getObjectMirror(e.functionId) : null, o = null == t ? i : t, a = e.scopeIndex;
      if (a < 0 || a >= o.scopeCount()) throw new Error("Invalid scope index");
      var s = o.scope(a).details_, u = s.type() == b.Local || s.type() == b.Closure, c = [];
      return '{"id":' + this.getOrCreateMirror(s.object(), c, e.includeProperties, 1e3, u).handle() + n(c) + "}";
    }, t.prototype.evaluate = function(r, t) {
      var i;
      if (null != r.additionalContext) {
        i = {};
        for (var o = 0, a = r.additionalContext.length; o < a; o++) {
          var u = r.additionalContext[o];
          i[u.name] = "handle" in u ? this.getObjectMirror(u.handle).value() : h.resolveValue_(u);
        }
      }
      var c;
      try {
        c = -1 == r.frame ? t.evaluateGlobal(r.expression, !r.enableBreak, i) : t.frame(r.frame).evaluate(r.expression, !r.enableBreak, i);
      } catch (e) {
        return this.wrapWasThrown(e, r.includeProperties);
      }
      var l = new O("");
      switch (c.type()) {
       case "undefined":
        l.type = 8;
        break;

       case "null":
        l.type = 9;
        break;

       case "boolean":
        l.type = 4, l.value = c.value();
        break;

       case "number":
        l.type = 1, l.value = s(c.value());
        break;

       case "string":
        var p = c.value();
        p.length <= 4096 && (l.type = 2, l.value = p);
      }
      if (null == l.type) {
        var f = [];
        return l.objectId = c.handle(), this.describeObjectMirror(c, r.includeProperties, f, 1e3), 
        e.cacheManager.cacheMirror(c), '{"result":' + JSON.stringify(l) + n(f) + "}";
      }
      var g = e.cacheManager.v8mc();
      return null != g && delete g[c.handle()], '{"result":' + JSON.stringify(l) + "}";
    }, t.prototype.wrapWasThrown = function(r, t) {
      var i = new O("wasThrown");
      if ("string" == typeof r) return i.type = 2, i.value = r, '{"result":' + JSON.stringify(i) + "}";
      var o = [];
      i.type = 0;
      var a = new u(r, "object", !1);
      return e.cacheManager.cacheMirror(a), this.describeObject2(a, a.className(), r.toString(), t, 1e3, o), 
      i.objectId = a.handle(), '{"result":' + JSON.stringify(i) + n(o) + "}";
    }, t.prototype.describeObjectMirror = function(e, r, t, n) {
      switch (e.type()) {
       case "function":
        this.describeFunction(e, r, n, t);
        break;

       case "string":
        this.describeString(e, n, t);
        break;

       default:
        e.isArray() ? this.describeArray(e, r, n, t) : this.describeObject(e, r, n, t);
      }
    }, t.prototype.getObjects = function(e) {
      for (var r = e.ids, t = [], n = void 0 === e.maxStringLength ? 1e3 : e.maxStringLength, i = 0, o = r.length; i < o; i++) this.describeObjectMirror(this.getObjectMirror(r[i]), e.includeProperties, t, n);
      return '{"objects":' + JSON.stringify(t) + "}";
    }, t.prototype.getProperties = function(e) {
      var r = this.getObjectMirror(e.objectId), t = [];
      return '{"properties":' + JSON.stringify(this.describeProperties(r, t)) + n(t) + "}";
    }, t.prototype.getIndexedProperties = function(e) {
      var r = this.getObjectMirror(e.arrayId), t = 0, i = r.value_, o = r.isArray(), a = e.to;
      if (-1 === a && (a = i.length), o) for (var u = e.from; u < a; u++) u in i && t++; else t = a - e.from;
      if (t <= e.bucketThreshold) {
        if (void 0 !== e.componentType) {
          for (var c = '{"values":[', l = !0, p = 1 == e.componentType ? s : JSON.stringify, u = e.from; u < a; u++) l ? l = !1 : c += ",", 
          c += p(i[u]);
          return c + "]}";
        }
        var f = [], g = new Array(t);
        if (o) for (var u = e.from, d = 0; u < a; u++) u in i && (g[d++] = this.describeProperty(i[u], u, f, 1e3)); else for (var u = e.from, d = 0; u < a; u++) g[d++] = this.describeProperty(i[u], u, f, 1e3);
        return '{"properties":' + JSON.stringify(g) + n(f) + "}";
      }
      for (var v = Math.pow(e.bucketThreshold, Math.ceil(Math.log(t) / Math.log(e.bucketThreshold)) - 1), h = -1, y = 0, b = 0, c = "", l = !0, u = e.from; u < a; u++) (!o || u in i) && (-1 == h && (h = u), 
      y = u, ++b == v && (l ? l = !1 : c += ",", c += h + "," + y, b = 0, h = -1));
      return b > 0 && (l || (c += ","), c += h + "," + y), '{"ranges":[' + c + "]}";
    }, t.prototype.getFunction = function(e) {
      var r = this.getObjectMirror(e.id), n = r.script();
      return '{"fun":' + JSON.stringify(new m(null == n ? -1 : n.id(), t.getScopes(null, r, r), r.sourceLocation())) + "}";
    }, t.prototype.describeScript = function(e) {
      var r = e.source_url || e.name;
      if (null == r) return null;
      var t = e.source;
      if (null == t || 0 === t.length || "j" == t[0] && 0 === t.lastIndexOf("javascript:void(0);", 0)) return null;
      var n = {
        id: e.id,
        path: r,
        type: e.type,
        endLine: e.line_offset + e.line_ends.length - 1
      }, i = e.line_offset;
      0 !== i && (n.startLine = i);
      var o = e.column_offset;
      0 !== o && (n.startColumn = o);
      var a = y.exec(t);
      return null != a && a.length > 1 && (n.sourceMapUrl = a[1]), n;
    }, t.prototype.describeFrame = function(e, r, n) {
      void 0 === n && (n = 1e3);
      var i = e.details_, o = t.getScopes(e, null, e), a = this.getOrCreateMirror(i.func(), r, !1, n), s = a.script(), u = null == s ? -1 : s.id();
      return new M(e.index(), t.getFunctionName(a), a.handle(), u, o, e.sourceLocation(), void 0 !== i.receiver());
    }, t.getScopes = function(e, r, t) {
      if (null != e && "allScopes" in e) {
        for (var n = e.allScopes(!0), i = n.length, o = new Array(i), a = 0; a < i; a++) o[a] = {
          type: n[a].scopeType(),
          index: a
        };
        return o;
      }
      var i = t.scopeCount(), o = new Array(i);
      if (null != r && "scope" in r) for (var a = 0; a < i; a++) o[a] = {
        type: r.scope(a).scopeType(),
        index: a
      }; else for (var a = 0; a < i; a++) o[a] = {
        type: new v(e, r, a).type(),
        index: a
      };
      return o;
    }, t.prototype.getOrCreateMirror = function(r, n, i, o, a, s) {
      if (void 0 === a && (a = !1), void 0 === s && (s = !1), !a) {
        var c = e.cacheManager.findMirror(r);
        if (null != c) return c;
      }
      var d = typeof r;
      if ("string" === d) return this.mirrorAndDescribeString(r, o, n);
      if (Array.isArray(r)) {
        var v = new p(r);
        return e.cacheManager.cacheMirror(v), this.describeArray(v, i, o, n), v;
      }
      if ("function" === d) {
        var h = new l(r);
        return e.cacheManager.cacheMirror(h), this.describeFunction(h, i, o, n), h;
      }
      var y = t.getConstructorName(r);
      if ("String" === y) return this.mirrorAndDescribeString(r, o, n);
      var b;
      return b = "Date" === y ? new f(r) : "RegExp" === y ? new g(r) : new u(r, "object", a), 
      e.cacheManager.cacheMirror(b), this.describeObject(b, i, o, n, s), b;
    }, t.getConstructorName = function(e) {
      return "function" == typeof e.constructor ? e.constructor.name : null;
    }, t.prototype.describeObject = function(e, r, n, i, o) {
      void 0 === o && (o = !1);
      var a, s;
      if (e.isDate() || e.isRegExp()) a = e.value().toString(), s = e.isDate() ? "Date" : "RegExp"; else if (s = t.getClassName(e), 
      !o && ("Buffer" === s || isTypedArray(s))) {
        var u = this.describe(e, 6, s, e.value().length, e, r, n, i);
        return u.className = s, u;
      }
      return this.describeObject2(e, s, a, r, n, i);
    }, t.getClassName = function(e) {
      var r = e.className();
      if (null != r && 0 != r.length && "Object" !== r) return r;
      var n = e.value();
      if ("function" == typeof n.constructor && (null == (r = n.constructor.name) || 0 == r.length || "Object" === r)) {
        var i = e.constructorFunction();
        null != i && i.isFunction() && "Object" === (r = t.getFunctionName(i)) && (r = null);
      }
      return r;
    }, t.prototype.describeObject2 = function(e, r, t, n, i, o) {
      var a = this.describe(e, 0, t, -1, e, n, i, o);
      return null != r && (a.className = r), a;
    }, t.prototype.describeArray = function(e, r, t, n) {
      return this.describe(e, 6, e.className(), e.length(), e, r, t, n);
    }, t.prototype.describeFunction = function(e, r, t, n) {
      for (var i = e.source(), s = 0; s < i.length && !o(i, s); ) s++;
      for (;s > 0 && a(i, s - 1); ) s--;
      i = i.substring(0, s), this.describe(e, 3, i, -1, e, r, t, n);
    }, t.getFunctionName = function(e) {
      var r = e.name();
      return null != r && 0 != r.length || (r = e.inferredName()), null == r || 0 == r.length ? null : r;
    }, t.prototype.describeString = function(e, t, n) {
      var i = e.length();
      return this.describe(e, 2, r(e, t), i > 1e3 ? i : -1, null, !1, t, n);
    }, t.prototype.mirrorAndDescribeString = function(r, t, n) {
      var i = new c(r);
      return e.cacheManager.cacheMirror(i), this.describeString(i, t, n), i;
    }, t.prototype.describe = function(e, r, t, n, i, o, a, s) {
      var u = new S(e.handle(), r, t, n);
      return null != i && o && (u.properties = this.describeProperties(i, s, a)), s.push(u), 
      u;
    }, t.prototype.describeProperties = function(e, r, n) {
      void 0 === n && (n = 1e3);
      var i;
      if (e.handle() < 0) i = null; else {
        var o = Object.getPrototypeOf(e.value_);
        null == o ? i = null : (i = new O("__proto__"), i.objectId = this.getOrCreateMirror(o, r, !1, n, !1, !0).handle());
      }
      var a = t.getClassName(e), s = null == d, u = isTypedArray(a) ? typedArrayProperties : s ? e.propertyNames() : e.propertyNames(d.Named, NaN), c = e.isArray();
      s || c || (u = u.concat(e.propertyNames(d.Indexed, NaN)));
      for (var l = new Array(u.length + (null == i ? 0 : 1)), p = 0, f = 0, g = u; f < g.length; f++) {
        var v = g[f];
        "symbol" != typeof v && (s && c && isIndexed(v) || (l[p++] = this.describePropertyByMirror(e, v, r, n)));
      }
      return null != i && (l[p++] = i), l.length = p, l;
    }, t.prototype.describePropertyByMirror = function(e, r, t, n) {
      var i = e.property(r);
      if (null != i.getter_ || null != i.setter_) {
        var o = new O(r);
        if (null != i.getter_) {
          var a = this.getOrCreateMirror(i.getter_, t, !1, n);
          if (o.getter = a.handle(), !a.isFunction()) throw new Error("Incorrect getter type: " + a.type);
        }
        if (null != i.setter_) {
          var a = this.getOrCreateMirror(i.setter_, t, !1, n);
          if (o.setter = a.handle(), !a.isFunction()) throw new Error("Incorrect setter type: " + a.type);
        }
        return o;
      }
      var s = i.value_;
      if (void 0 === s) try {
        var u = e.value_;
        null != u && (s = u[r]);
      } catch (e) {
        console.error(e);
      }
      return this.describeProperty(s, r, t, n);
    }, t.prototype.describeProperty = function(e, r, t, n) {
      var i = new O(r);
      if (void 0 === e) i.type = 8; else if (null === e) i.type = 9; else {
        var o = typeof e;
        "boolean" === o ? (i.type = 4, i.value = e) : "number" === o ? (i.type = 1, i.value = s(e)) : "string" === o && e.length <= 4096 ? (i.type = 2, 
        i.value = e) : i.objectId = this.getOrCreateMirror(e, t, !1, n, !1, "prototype" === r).handle();
      }
      return i;
    }, t;
  }();
  e.DebuggerSupport = _;
}($_JbV8DebuggerSupport || ($_JbV8DebuggerSupport = {}));

var typedArrayProperties = [ "buffer", "byteLength", "byteOffset", "length" ], $_JbV8DebuggerSupport;

!function(e) {
  function r(e, r) {
    return '{"success": false, "message": ' + JSON.stringify("Error while sending " + r + " event:\n\n" + (e.stack || e.message)) + "}";
  }
  var t = v8debug.DebugCommandProcessor, n = v8debug.BreakEvent, i = v8debug.CompileEvent, o = v8debug.BreakPoint, a = new e.DebuggerSupport();
  t.prototype.super$processDebugJSONRequest = t.prototype.processDebugJSONRequest, 
  t.prototype.processDebugJSONRequest = function(r) {
    var t;
    try {
      t = JSON.parse(r);
    } catch (e) {
      return '{"success": false, "type": "internal error", "message": ' + JSON.stringify("Cannot parse incoming message:" + r + "\n\n" + e) + "}";
    }
    var n = this;
    try {
      if (null == t.command) throw new Error("Command not specified");
      var i;
      switch (t.command) {
       case "getScopeObject":
        i = a.getScopeObject(t.arguments, n.exec_state_);
        break;

       case "getFrames":
        i = a.getFrames(t.arguments, n.exec_state_);
        break;

       case "getFrameReceiver":
        i = a.getFrameReceiver(t.arguments, n.exec_state_);
        break;

       case "getObjects":
        i = a.getObjects(t.arguments);
        break;

       case "getProperties":
        i = a.getProperties(t.arguments);
        break;

       case "getIndexedProperties":
        i = a.getIndexedProperties(t.arguments);
        break;

       case "getFunction":
        i = a.getFunction(t.arguments);
        break;

       case "getScripts":
        var o, s = v8debug.Debug.scripts(), u = [], c = null == t.arguments ? null : t.arguments.ids;
        if (null != c) {
          o = {};
          for (var l = 0; l < c.length; l++) o[c[l]] = !0;
        }
        for (var l = 0, p = s.length; l < p; l++) {
          var f = s[l];
          if (null == c) {
            if (0 === f.type) continue;
          } else if (!o[f.id]) continue;
          var g = a.describeScript(f);
          null != g && u.push(g);
        }
        i = '{"scripts": ' + JSON.stringify(u) + "}";
        break;

       case "evaluate":
        i = a.evaluate(t.arguments, n.exec_state_);
        break;

       case "continue":
       case "disconnect":
        e.cacheManager.clearCache();

       default:
        return n.super$processDebugJSONRequest(r);
      }
      return '{"request_seq": ' + t.seq + ', "success": true, "running": ' + n.running_ + ', "body": ' + i + "}";
    } catch (e) {
      return '{"request_seq": ' + t.seq + ', "success": false, "running": ' + n.running_ + ', "message":' + JSON.stringify(e.stack || e.toString()) + "}";
    }
  }, null != n && (n.prototype.super$toJSONProtocol = n.prototype.toJSONProtocol, 
  n.prototype.toJSONProtocol = function() {
    try {
      var t = this.breakPointsHit();
      if (null != t) for (var n = new Array(t.length), i = 0; i < t.length; i++) {
        var o = t[i], s = o.script_break_point();
        n[i] = null == s ? o.number() : s.number();
      }
      var u = [], c = this.frame_ || this.exec_state_.frame(0), l = null == this.exec_state_ ? "" : ', "frameCount": ' + JSON.stringify(this.exec_state_.frameCount());
      return '{"event": "paused", "body": {"frame": ' + JSON.stringify(a.describeFrame(c, u)) + l + e.stringifyList(n, "breakpoints") + e.stringifyObjects(u) + "}}";
    } catch (e) {
      return r(e, "break");
    }
  }), null != i && (i.prototype.super$toJSONProtocol = i.prototype.toJSONProtocol, 
  i.prototype.toJSONProtocol = function() {
    var e = this;
    try {
      if (5 != e.eventType()) return e.super$toJSONProtocol();
      var t = e.script().value(), n = 0 === t.type ? null : a.describeScript(t);
      return null == n ? '{"event": "scriptParsed", "ignoredScriptId": ' + (null == t.id ? '""' : t.id) + "}" : '{"event": "scriptParsed", "body": {"script": ' + JSON.stringify(n) + "}}";
    } catch (e) {
      return r(e, "scriptParsed");
    }
  }), null != o && (o.prototype.super$isTriggered = o.prototype.isTriggered, o.prototype.isTriggered = function(e) {
    var r = this;
    if (!r.active()) return !1;
    var t = r.condition();
    if (null != t && 0 === t.lastIndexOf("// jb sourcemap condition", 0)) {
      var n = e.frame(0).func().script();
      if (null != n) return -1 !== n.source().lastIndexOf("sourceMappingURL=");
    }
    return r.super$isTriggered(e);
  });
}($_JbV8DebuggerSupport || ($_JbV8DebuggerSupport = {}));
(v8debug.CompileEvent != null) + "|" + process.pid + "|" + (process.argv.join(","))